using NAT.Common;
using NAT.Common.Handlers;
using NAT.Common.Handlers.Configs;
using NAT.Common.Models;

namespace NAT.BM.Handlers
{
    sealed class HipClothingHandler : ClothingHandler
    {
        internal HipClothingHandler(ScriptBase script) : base(script)
        {
            ClothingProfilesDir = "HipClothingProfiles";
            validRegionTags = new[] { "full body", "hip", "legs" };
            invalidRegionTags = new[] { "torso", "arms", "feet", "hands", "head", "legs", "neck" };
            presetHandler = new ClothingPresetHandler(Script, this, ClothingProfilesDir);
            LoadSettings();
            initialized = true;
        }

        internal override void SetMultipliers()
        {
            upDownMassMultiplier = 1f;
            sidewaysMassMultiplier = 1f;
            inOutMassMultiplier = 1f;
        }

        protected override ClothingAdjustmentProfile GetProfile(ClothingItem item) => item.hipProfile;
        protected override void SetProfile(ClothingItem item, ClothingAdjustmentProfile profile) => item.hipProfile = profile;
    }
}
