// ReSharper disable MemberCanBePrivate.Global
// ReSharper disable AutoPropertyCanBeMadeGetOnly.Global
using ColliderEditor.Extensions;

namespace ColliderEditor
{
    sealed class ColliderPreviewConfig
    {
        internal const float EXPONENTIAL_SCALE_MIDDLE = 0.1f;

        internal const bool DEFAULT_PREVIEWS_ENABLED = false;
        internal const bool DEFAULT_X_RAY_PREVIEWS = true;
        internal const float DEFAULT_PREVIEWS_OPACITY = 0.5f;
        internal const float DEFAULT_SELECTED_PREVIEW_OPACITY = 1.0f;
        internal const float DEFAULT_RELATIVE_X_RAY_OPACITY = 0.5f;
        internal const bool DEFAULT_HIGHLIGHT_MIRROR = false;

        internal bool previewsEnabled = DEFAULT_PREVIEWS_ENABLED;
        internal bool xRayPreviews = DEFAULT_X_RAY_PREVIEWS;
        internal bool highlightMirror = DEFAULT_HIGHLIGHT_MIRROR;
        internal float previewsOpacity = DEFAULT_PREVIEWS_OPACITY.ExponentialScale(EXPONENTIAL_SCALE_MIDDLE, 1f);
        internal float selectedPreviewsOpacity = DEFAULT_SELECTED_PREVIEW_OPACITY.ExponentialScale(EXPONENTIAL_SCALE_MIDDLE, 1f);
        internal float relativeXRayOpacity = DEFAULT_RELATIVE_X_RAY_OPACITY;
    }
}
