using MeshVR;

namespace NAT.Common.Components
{
    struct PresetParams
    {
        readonly string _presetName;
        readonly bool _storeOptional; // Pose: Store Root Node In Pose
        readonly bool _storeOptional2; // Pose: Store Bones In Pose
        readonly bool _storeOptional3; // Pose: Store Pose Morphs In Pose

        internal PresetParams(
            string presetName,
            bool storeOptional,
            bool storeOptional2,
            bool storeOptional3
        )
        {
            _presetName = presetName;
            _storeOptional = storeOptional;
            _storeOptional2 = storeOptional2;
            _storeOptional3 = storeOptional3;
        }

        internal static PresetParams GetParamsFromControl(PresetManagerControl pmc) => new PresetParams(
            pmc.GetStringParamValue("presetName"),
            pmc.GetBoolParamValue("storeOptional"),
            pmc.GetBoolParamValue("storeOptional2"),
            pmc.GetBoolParamValue("storeOptional3")
        );

        internal void SetParamsToControl(PresetManagerControl pmc)
        {
            pmc.SetStringParamValue("presetName", _presetName);
            pmc.SetBoolParamValue("storeOptional", _storeOptional);
            pmc.SetBoolParamValue("storeOptional2", _storeOptional2);
            pmc.SetBoolParamValue("storeOptional3", _storeOptional3);
        }
    }
}
