using NAT.Common.Models;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;

namespace NAT.Common.Contexts
{
    abstract class SoftPhysicsContext : Context
    {
        internal SoftJoint[] allSoftJoints;
        internal SoftJoint[] outerSoftJoints;
        internal SoftJoint[] mainSoftJoints;
        internal SoftJoint[] centerSoftJoints;
        internal SoftJoint nippleSoftJoint;
        internal Rigidbody[] centerSoftJointsRigidbodies;
        internal List<GradientGroup> gradientGroups;
        internal readonly Dictionary<string, int[]> positionalIndices = new Dictionary<string, int[]>();
        internal Dictionary<int, int> mirrorVertexIndices;

        protected SoftPhysicsContext(string id) : base(id)
        {
        }

        internal SoftJoint FindSoftJointFromMirror(int fromIndex)
        {
            int index = mirrorVertexIndices[fromIndex];
            return allSoftJoints.First(softJoint => softJoint.softVerticesSet.targetVertex == index);
        }
    }
}
