// ReSharper disable UnusedMember.Global
using NAT;
using NAT.Common.Storables;
using SimpleJSON;

namespace Naturalis.Common.Handlers.Configs
{
    class AdjustmentBoolParam
    {
        internal readonly StorableBool storableParam;
        bool _savedValue;

        internal AdjustmentBoolParam(StorableBool storableParam)
        {
            this.storableParam = storableParam;
        }

        internal string Name => storableParam.name;
        internal bool Value => storableParam.val;
        internal void SetVal(bool value) => storableParam.SetVal(value);
        internal void SetValNoCallback(bool value) => storableParam.valNoCallback = value;
        internal void SetValFromJSON(JSONClass jc) => storableParam.SetValFromJSON(jc);
        internal void SetDefaultValNoCallback() => storableParam.SetDefaultValNoCallback();
        internal void CopyFrom(AdjustmentBoolParam other) => storableParam.valNoCallback = other.storableParam.val;
        internal void SaveValue() => _savedValue = storableParam.val;
        internal bool IsSaved => storableParam.val == _savedValue;
    }
}
