using NAT;
using NAT.Common.Storables;
using SimpleJSON;

namespace Naturalis.Common.Handlers.Configs
{
    class AdjustmentFloatParam
    {
        const float TOLERANCE = 0.00001f;
        internal readonly StorableFloat storableParam;
        internal float adjustedValue;
        float _savedValue;

        internal AdjustmentFloatParam(StorableFloat storableParam)
        {
            this.storableParam = storableParam;
        }

        internal string Name => storableParam.name;
        internal float Value => storableParam.val;
        internal void SetVal(float value) => storableParam.SetVal(value);
        internal void SetValNoCallback(float value) => storableParam.valNoCallback = value;
        internal void SetValFromJSON(JSONClass jc) => storableParam.SetValFromJSON(jc);
        internal void SetDefaultValNoCallback() => storableParam.SetDefaultValNoCallback();

        internal void CopyFrom(AdjustmentFloatParam other)
        {
            storableParam.valNoCallback = other.storableParam.val;
            adjustedValue = other.adjustedValue;
        }

        internal void SaveValue() => _savedValue = storableParam.val;
        internal bool IsSaved => storableParam.val.IsEqual(_savedValue, TOLERANCE);
    }
}
