// ReSharper disable UnusedMember.Global
using NAT;
using NAT.Common.Storables;

namespace Naturalis.Common.Handlers.Configs
{
    class AdjustmentStringParam
    {
        // ReSharper disable once MemberCanBePrivate.Global
        internal readonly StorableString storableParam;
        string _savedValue;

        internal AdjustmentStringParam(StorableString storableParam)
        {
            this.storableParam = storableParam;
        }

        internal string Name => storableParam.name;
        internal string Value => storableParam.val;

        internal void SetVal(string value) => storableParam.SetVal(value);
        internal void SetValNoCallback(string value) => storableParam.valNoCallback = value;
        internal void SetDefaultValNoCallback() => storableParam.SetDefaultValNoCallback();
        internal void CopyFrom(AdjustmentStringParam other) => storableParam.valNoCallback = other.storableParam.val;
        internal void SaveValue() => _savedValue = storableParam.val;
        internal bool IsSaved => storableParam.val == _savedValue;
    }
}
