using NAT.Common.Storables;
using UnityEngine;

namespace NAT.Common.Models
{
    class ClothingMorphConfig
    {
        internal readonly MorphWrapper left;
        internal readonly MorphWrapper right;
        internal readonly StorableFloat storableFloat;
        internal Vector3 offsetsCompensation = Vector3.zero;
        internal Vector3 GetLeftMorphsOffsetsCompensation() => offsetsCompensation * left.GetValue();

        internal Vector3 GetRightMorphsOffsetsCompensation() =>
            new Vector3(-offsetsCompensation.x, offsetsCompensation.y, offsetsCompensation.z) * right.GetValue();

        internal ClothingMorphConfig(DAZMorph left, DAZMorph right, StorableFloat storableFloat)
        {
            this.left = new MorphWrapper(left);
            this.right = new MorphWrapper(right);
            this.storableFloat = storableFloat;
        }
    }
}
