using NAT.Common.Storables;

namespace NAT.Common.Handlers.Configs
{
    class GradientConfig
    {
        internal StorableFloat middleShiftJsf; // middle offset of gradient from -1 (outermost joint) to 1 (center joint)
        internal StorableFloat outerMultiplierJsf; // multiplier for the outermost joint value
        internal StorableFloat centerMultiplierJsf; // multiplier for the center joint value (TittyMagic) or the main1 and center joint values (BootyMagic)
        internal StorableFloat nippleMultiplierJsf; // multiplier for the nipple joint value
        internal float outerToMiddleCurvature; // curvature of smoothstep function from 0 (outermost joint) to middle
        internal float outerToMiddleMidPoint; // mid point of smoothstep function from 0 (outermost joint) to middle
        internal float middleToCenterCurvature; // curvature of smoothstep function from middle to 1 (center joint)
        internal float middleToCenterMidPoint; // mid point of smoothstep function from middle to 1 (center joint)

        internal bool IsModified =>
            middleShiftJsf.IsModified ||
            outerMultiplierJsf.IsModified ||
            centerMultiplierJsf.IsModified ||
            (nippleMultiplierJsf?.IsModified ?? false);
    }
}
