﻿namespace NAT.Common.Handlers
{
    abstract class Handler
    {
        protected ScriptBase Script { get; }
        protected Person Person { get; private set; }
        protected bool initialized = false;

        protected Handler(ScriptBase script)
        {
            Script = script;
            Person = Script.person;
        }

        internal virtual void Enable()
        {
        }

        protected abstract void LoadSettings();

        internal abstract void PreRegisterParams();

        internal virtual void SetMultipliers()
        {
        }

        internal virtual void SaveCalibrated()
        {
        }

        internal virtual void OnFixedUpdate()
        {
        }

        internal virtual void ResetAll()
        {
        }

        internal virtual void Disable()
        {
        }

        internal virtual void Destroy()
        {
        }
    }
}
