﻿using GPUTools.Physics.Scripts.Behaviours;
using UnityEngine;

namespace NAT.Common.Models
{
    sealed class CapsuleHardCollider : HardCollider
    {
        readonly CapsuleCollider _capsuleCollider;
        readonly CapsuleLineSphereCollider _gpuCollider;
        readonly bool _hasGpuCollider;

        protected override Vector3 Center
        {
            get { return _capsuleCollider.center; }
            set
            {
                _capsuleCollider.center = value;
                if(_hasGpuCollider)
                {
                    _gpuCollider.UpdateData();
                }
            }
        }

        internal CapsuleHardCollider(
            string id,
            AutoCollider autoCollider,
            AutoColliderParams autoColliderParams
        )
            : base(id, autoCollider, autoColliderParams)
        {
            _capsuleCollider = (CapsuleCollider) collider;
            _capsuleCollider.enabled = true;
            _gpuCollider = _capsuleCollider.GetComponent<CapsuleLineSphereCollider>();
            _hasGpuCollider = _gpuCollider != null;
        }
    }
}
