namespace NAT.Common.Models
{
    class MorphWrapper
    {
        DAZMorph _dazMorph;
        readonly string _uid;
        readonly DAZMorphBank _morphBank;
        bool _enabled = true;

        internal MorphWrapper(DAZMorph dazMorph)
        {
            _dazMorph = dazMorph;
            _uid = dazMorph.uid;
            _morphBank = dazMorph.morphBank;
        }

        internal void SetValue(float value)
        {
            if(!_enabled)
            {
                return;
            }

            if(_dazMorph.isDemandLoaded && !_dazMorph.isDemandActivated)
            {
                _dazMorph = _morphBank.GetMorphByUid(_uid); // Reactivates the morph in case it has been unloaded by e.g. memory optimization
                if(_dazMorph == null)
                {
                    SuperController.LogError($"Naturalis: Morph with uid '{_uid}' not found!");
                    _enabled = false;
                    return;
                }
            }

            _dazMorph.morphValue = value;
        }

        internal float GetValue() => _dazMorph.morphValue;

        internal void Reset() => SetValue(0);
    }
}
