﻿using UnityEngine;

namespace NAT.Common.Models
{
    sealed class SphereHardCollider : HardCollider
    {
        readonly SphereCollider _sphereCollider;

        protected override Vector3 Center
        {
            get { return _sphereCollider.center; }
            set { _sphereCollider.center = value; }
        }

        internal SphereHardCollider(
            string id,
            AutoCollider autoCollider,
            AutoColliderParams autoColliderParams
        )
            : base(id, autoCollider, autoColliderParams)
        {
            _sphereCollider = (SphereCollider) collider;
            _sphereCollider.enabled = true;
        }
    }
}
