﻿// ReSharper disable InconsistentNaming
namespace NAT
{
    /* Joint physics */

    static class BREAST_JOINT_MASS
    {
        internal const string NAME = "Breast Joint Mass";
        internal const float MIN = 0.150f;
        internal const float MAX = 3.000f;
        internal const string FORMAT = "F3";
    }

    static class GLUTE_JOINT_MASS
    {
        internal const string NAME = "Glute Joint Mass";
        internal const float MIN = 1.000f;
        internal const float MAX = 3.000f;
        internal const string FORMAT = "F3";
    }

    static class CENTER_OF_GRAVITY
    {
        internal const string NAME = "Center Of Gravity";
        internal const float MIN = 0.00f;
        internal const float MAX = 1.00f;
        internal const string FORMAT = "F2";
    }

    static class ROTATION_SPRING
    {
        internal const string NAME = "Rotation Spring";
        internal const float MIN = 10f;
        internal const float MAX = 200f;
        internal const string FORMAT = "F0";
    }

    static class ROTATION_DAMPER
    {
        internal const string NAME = "Rotation Damper";
        internal const float MIN = 0.00f;
        internal const float MAX = 5.00f;
        internal const string FORMAT = "F2";
    }

    // static class ANGULAR_SPRING
    // {
    //     internal const string NAME = "Angular Spring";
    //     internal const float MIN = 0f;
    //     internal const float MAX = 1000f;
    // }
    //
    // static class ANGULAR_DAMPER
    // {
    //     internal const string NAME = "Angular Damper";
    //     internal const float MIN = 0.00f;
    //     internal const float MAX = 50.00f;
    // }

    // static class UP_DOWN_SPRING
    // {
    //     internal const string NAME = "Up/Down Spring";
    //     internal const float MIN = 0f;
    //     internal const float MAX = 5000f;
    // }
    //
    // static class UP_DOWN_DAMPER
    // {
    //     internal const string NAME = "Up/Down Damper";
    //     internal const float MIN = 0f;
    //     internal const float MAX = 100f;
    // }

    static class RIGHT_LEFT_SPRING
    {
        internal const string NAME = "Right/Left Spring";
        internal const float MIN = 0f;
        internal const float MAX = 5000f;
        internal const string FORMAT = "F0";
    }

    static class RIGHT_LEFT_DAMPER
    {
        internal const string NAME = "Right/Left Damper";
        internal const float MIN = 0f;
        internal const float MAX = 100f;
        internal const string FORMAT = "F2";
    }

    static class IN_OUT_SPRING
    {
        internal const string NAME = "In/Out Spring";
        internal const float MIN = 0f;
        internal const float MAX = 5000f;
        internal const string FORMAT = "F0";
    }

    static class IN_OUT_DAMPER
    {
        internal const string NAME = "In/Out Damper";
        internal const float MIN = 0f;
        internal const float MAX = 50f;
        internal const string FORMAT = "F2";
    }

    static class GLUTE_UP_DOWN_BASE_ANGLE
    {
        internal const string NAME = "Up/Down Base Angle";
        internal const float MIN = -15.0f;
        internal const float MAX = 15.0f;
        internal const string FORMAT = "F1";
    }

    static class BREAST_UP_DOWN_BASE_ANGLE
    {
        internal const string NAME = "Up/Down Base Angle";
        internal const float MIN = -10.0f;
        internal const float MAX = 20.0f;
        internal const string FORMAT = "F1";
    }

    static class UP_ANGLE_LIMIT
    {
        internal const string NAME = "Up Angle Limit";
        internal const float MIN = 0.0f;
        internal const float MAX = 40.0f;
        internal const string FORMAT = "F1";
    }

    static class DOWN_ANGLE_LIMIT
    {
        internal const string NAME = "Down Angle Limit";
        internal const float MIN = -40.0f;
        internal const float MAX = 0.0f;
        internal const string FORMAT = "F1";
    }

    static class GLUTE_UP_DOWN_ANGLE_TARGET
    {
        internal const string NAME = "Up/Down Angle Target";
        internal const float MIN = -15.0f;
        internal const float MAX = 30.0f;
        internal const string FORMAT = "F1";
    }

    static class BREAST_UP_DOWN_ANGLE_TARGET
    {
        internal const string NAME = "Up/Down Angle Target";
        internal const float MIN = -20.0f;
        internal const float MAX = 20.0f;
        internal const string FORMAT = "F1";
    }

    static class RIGHT_LEFT_BASE_ANGLE
    {
        internal const string NAME = "Right/Left Base Angle";
        internal const float MIN = -10.0f;
        internal const float MAX = 10.0f;
        internal const string FORMAT = "F1";
    }

    static class RIGHT_LEFT_ANGLE_LIMIT
    {
        internal const string NAME = "Right/Left Angle Limit";
        internal const float MIN = 0.0f;
        internal const float MAX = 40.0f;
        internal const string FORMAT = "F1";
    }

    static class RIGHT_LEFT_ANGLE_TARGET
    {
        internal const string NAME = "Right/Left Angle Target";
        internal const float MIN = -20.0f;
        internal const float MAX = 20.0f;
        internal const string FORMAT = "F1";
    }

    static class TWIST_ANGLE_TARGET
    {
        internal const string NAME = "Twist Angle Target";
        internal const float MIN = -30.0f;
        internal const float MAX = 30.0f;
        internal const string FORMAT = "F1";
    }

    /* Soft physics */

    static class FAT_SPRING
    {
        internal const string NAME = "Fat Spring";
        internal const float MIN = 5f;
        internal const float MAX = 1000f;
        internal const float GRADIENT_MAX = MAX * Constant.GRADIENT_MULTI_MAX;
        internal const string FORMAT = "F1";
    }

    static class FAT_DAMPER
    {
        internal const string NAME = "Fat Damper";
        internal const float MIN = 0.00f;
        internal const float MAX = 10.00f;
        internal const float GRADIENT_MAX = MAX * Constant.GRADIENT_MULTI_MAX;
        internal const string FORMAT = "F2";
    }

    static class FAT_MASS
    {
        internal const string NAME = "Fat Mass";
        internal const float MIN = 0.010f;
        internal const float MAX = 0.300f;
        internal const float GRADIENT_MAX = MAX * Constant.GRADIENT_MULTI_MAX;
        internal const string FORMAT = "F3";
    }

    static class FAT_COLLIDER_RADIUS
    {
        internal const string NAME = "Fat Collider Radius";
        internal const float MIN = 0.0010f;
        internal const float MAX = 0.0600f;
        internal const float GRADIENT_MAX = MAX * Constant.GRADIENT_MULTI_MAX;
        internal const string FORMAT = "F4";
    }

    static class FAT_COLLIDER_DEPTH
    {
        internal const string NAME = "Fat Collider Depth";
        internal const float MIN = -0.0050f;
        internal const float MAX = 0.0050f;
        internal const float GRADIENT_MIN = MIN * Constant.GRADIENT_MULTI_MAX;
        internal const float GRADIENT_MAX = MAX * Constant.GRADIENT_MULTI_MAX;
        internal const string FORMAT = "F4";
    }

    static class FAT_COLLIDER_FRICTION
    {
        internal const string NAME = "Fat Collider Friction";
        internal const float MIN = 0.000f;
        internal const float MAX = 1.000f;
        internal const string FORMAT = "F3";
    }

    static class FAT_DISTANCE_LIMIT
    {
        internal const string NAME = "Fat Distance Limit";
        internal const float MIN = 0.000f;
        internal const float MAX = 0.100f;
        internal const float GRADIENT_MAX = MAX * Constant.GRADIENT_MULTI_MAX;
        internal const string FORMAT = "F3";
    }

    static class FAT_BACK_FORCE
    {
        internal const string NAME = "Fat Back Force";
        internal const float MIN = 0.00f;
        internal const float MAX = 50.00f;
        internal const string FORMAT = "F2";
    }

    static class FAT_BACK_FORCE_MAX_FORCE
    {
        internal const string NAME = "Fat Back Force Max Force";
        internal const float MIN = 0.00f;
        internal const float MAX = 50.00f;
        internal const string FORMAT = "F2";
    }

    static class FAT_BACK_FORCE_THRESHOLD
    {
        internal const string NAME = "Fat Back Force Threshold";
        internal const float MIN = 0.000f;
        internal const float MAX = 0.030f;
        internal const string FORMAT = "F3";
    }

    /* Hard colliders */

    static class COLLIDER_MASS_MULTIPLIER
    {
        internal const string NAME = "Mass Multiplier";
        internal const float MIN = 0.01f;
        internal const float MAX = 4.00f;
        internal const string FORMAT = "F2";
    }

    static class COLLIDER_SPRING_MULTIPLIER
    {
        internal const string NAME = "Spring Multiplier";
        internal const float MIN = 0.01f;
        internal const float MAX = 4.00f;
        internal const string FORMAT = "F2";
    }

    static class COLLIDER_DAMPER_MULTIPLIER
    {
        internal const string NAME = "Damper Multiplier";
        internal const float MIN = 0.00f;
        internal const float MAX = 4.00f;
        internal const string FORMAT = "F2";
    }

    static class COLLIDER_RADIUS_OFFSET
    {
        internal const string NAME = "Radius Offset";
        internal const float MIN = -0.0200f;
        internal const float MAX = 0.0200f;
        internal const string FORMAT = "F4";
    }

    static class COLLIDER_DEPTH_OFFSET
    {
        internal const string NAME = "Depth Offset";
        internal const float MIN = -0.0200f;
        internal const float MAX = 0.0200f;
        internal const string FORMAT = "F4";
    }
}
