namespace NAT.Common.Storables
{
    sealed class StorableString : JSONStorableString, IStorableParam
    {
        public string Name => name;
        public bool Temporary { get; set; }
        public bool IsModified => val != defaultVal;
        public bool IsCalibrated => true;

        internal StorableString(string paramName, string startingValue) : base(paramName, startingValue)
        {
            storeType = StoreType.Full;
        }

        public void RegisterTo(MVRScript script) => script.RegisterString(this);
    }
}
