using NAT.Common.Handlers;
using System;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;

namespace NAT.Common.UI.Windows
{
    sealed class DevMorphWindow : Window
    {
        readonly ForceMorphHandler _forceMorphHandler;
        readonly Dictionary<string, UIDynamic> _sectionElements = new Dictionary<string, UIDynamic>();
        readonly JSONStorableString _morphDisplayValueJss = new JSONStorableString("morphDisplayValue", "");

        internal DevMorphWindow(ScriptBase script) : base(script, nameof(DevMorphWindow))
        {
            _forceMorphHandler = script.forceMorphHandler;
        }

        static string DirectionKey(string value) => value.EndsWith("_C") || value.StartsWith(Direction.LEFT) || value.StartsWith(Direction.RIGHT)
            ? value
            : $"{value}_L";

        static string DirectionKeyToSubDir(string value)
        {
            if(value.StartsWith("Up"))
            {
                return "UP/";
            }

            if(value.StartsWith("Back"))
            {
                return "BK/";
            }

            if(value.StartsWith("Forward"))
            {
                return "FW/";
            }

            if(value.StartsWith("Left"))
            {
                return "LT/";
            }

            if(value.StartsWith("Right"))
            {
                return "Right/";
            }

            Debug.Log("DirectionKeyToSubDir: " + value + " invalid");
            return "";
        }

        protected override void Build()
        {
            BuildLeftSide();
            BuildRightSide();
            RebuildSection(_forceMorphHandler.directionJssc.val);
        }

        void BuildLeftSide(bool rightSide = false)
        {
            // AddElement(() =>
            // {
            //     var button = script.CreateButton("Print", rightSide);
            //     button.AddListener(
            //         () =>
            //         {
            //             string directionKey = DirectionKey(_forceMorphHandler.directionJssc.val);
            //             var configs = _forceMorphHandler.morphSets[directionKey];
            //             string[] arr = configs
            //                 .Select(config => config.ToCodeString("GetBreastMorph", DirectionKeyToSubDir(directionKey)))
            //                 .ToArray();
            //             Debug.Log(string.Join("", arr));
            //         }
            //     );
            //     button.height = 55;
            //     return button;
            // });
            //
            // AddElement(() =>
            // {
            //     var button = script.CreateButton("Zero All", rightSide);
            //     button.AddListener(
            //         () =>
            //         {
            //             var configs = _forceMorphHandler.morphSets[DirectionKey(_forceMorphHandler.directionJssc.val)];
            //             foreach(var config in configs)
            //             {
            //                 config.massMultiplierJsf.val = 0;
            //                 config.softMultiplierJsf.val = 0;
            //             }
            //         }
            //     );
            //     button.height = 55;
            //     return button;
            // });

            // AddHeaderTextField("Softness Multiplier", rightSide);
        }

        void BuildRightSide(bool rightSide = true)
        {
            // AddSpacer(55, rightSide);
            // AddElement(_forceMorphHandler.directionJssc.name, () =>
            // {
            //     var popup = script.CreateFilterablePopup(_forceMorphHandler.directionJssc, rightSide);
            //     script.uiHandler.ConfigureCustomPopup(popup, 360f, false);
            //     script.uiHandler.AddPrevNextButtons(popup, true);
            //     popup.popup.onValueChangeHandlers += RebuildSection;
            //     return popup;
            // });

            // AddHeaderTextField("Mass Multiplier", rightSide);
        }

        void RebuildSection(string value)
        {
            // ClearSection();
            // var leftConfigs = _forceMorphHandler.morphSets[DirectionKey(value)];
            // foreach(var config in leftConfigs)
            // {
            //     AddSectionElement($"{config.morphDisplayName} Label", () =>
            //         CreateValueTextField(_morphDisplayValueJss, 28, 50, false)
            //     );
            //
            //     AddSectionElement($"{config.morphDisplayName} {config.isNegativeJsb.name}", () =>
            //     {
            //         var toggle = script.CreateToggle(config.isNegativeJsb, true);
            //         toggle.label = "Is Negative";
            //         return toggle;
            //     });
            //
            //     AddSectionElement($"{config.morphDisplayName} {config.softMultiplierJsf.name}", () =>
            //     {
            //         var slider = script.CreateSlider(config.softMultiplierJsf);
            //         slider.valueFormat = "F2";
            //         slider.label = "Softness Multiplier";
            //         return slider;
            //     });
            //
            //     AddSectionElement($"{config.morphDisplayName} {config.massMultiplierJsf.name}", () =>
            //     {
            //         var slider = script.CreateSlider(config.massMultiplierJsf, true);
            //         slider.valueFormat = "F2";
            //         slider.label = "Mass Multiplier";
            //         return slider;
            //     });
            // }
        }

        void AddSectionElement(string key, Func<UIDynamic> createElement)
        {
            _sectionElements[key] = createElement();
        }

        internal override void Clear()
        {
            base.Clear();
            ClearSection();
            RemoveDirectionPopupChangeHandler();
        }

        void RemoveDirectionPopupChangeHandler()
        {
            // var popup = GetUIDynamicAs<UIDynamicPopup>(_forceMorphHandler.directionJssc.name);
            // if(popup)
            // {
            //     popup.popup.visible = false;
            //     popup.popup.onValueChangeHandlers -= RebuildSection;
            // }
        }

        void ClearSection()
        {
            // foreach(var pair in _sectionElements)
            // {
            //     script.RemoveElement(pair.Value);
            // }
            //
            // _sectionElements.Clear();
        }
    }
}
