using System;
using System.Linq;

namespace NAT.Common
{
    sealed class ParsedPath
    {
        internal readonly string fullPath;
        internal readonly string packageId;
        internal readonly string itemSubDir;
        internal readonly string fileName;

        internal ParsedPath(string fullPath, string presetsDir)
        {
            // Debug.Log($"Parsing '{fullPath}' in preset dir '{presetDir}'");
            this.fullPath = fullPath;
            packageId = "";

            int packageUidSeparatorIdx = fullPath.IndexOf(":/", StringComparison.Ordinal);
            if(packageUidSeparatorIdx != -1)
            {
                packageId = fullPath.Substring(0, packageUidSeparatorIdx);
            }

            // Debug.Log($"PackageId: {packageId}");
            int startIndex = fullPath.IndexOf(presetsDir);
            if(startIndex != -1)
            {
                startIndex += presetsDir.Length + 1;
                string profileSubPath = fullPath.Substring(startIndex);
                // Debug.Log($"profileSubPath: {profileSubPath}");
                var split = profileSubPath.Split('/').ToList();
                if(split.Count > 2)
                {
                    itemSubDir = split[0] + "/" + split[1];
                    fileName = string.Join("/", split.Skip(2).ToArray());
                }
                else if(split.Count > 1)
                {
                    itemSubDir = split[0];
                    fileName = string.Join("/", split.Skip(1).ToArray());
                }
                else
                {
                    itemSubDir = "";
                    fileName = profileSubPath;
                }
                // Debug.Log($"itemSubDir: {itemSubDir}");
                // Debug.Log($"fileName: {fileName}");
            }
        }
    }
}
