using System.Collections.Generic;
using System.Text.RegularExpressions;

namespace NAT
{
    static class AtomExtensions
    {
        internal static IEnumerable<JSONStorable> FindStorablesByRegexMatch(this Atom atom, Regex regex)
        {
            var storableIds = atom.GetStorableIDs();
            foreach(string id in storableIds)
            {
                if(regex.IsMatch(id))
                {
                    yield return atom.GetStorableByID(id);
                }
            }
        }

        internal static bool StorableExistsByRegexMatch(this Atom atom, Regex regex)
        {
            var storableIds = atom.GetStorableIDs();
            foreach(string id in storableIds)
            {
                if(regex.IsMatch(id))
                {
                    return true;
                }
            }

            return false;
        }
    }
}
