﻿using System;
using System.Collections;
using UnityEngine;

namespace NAT
{
    static class MonoBehaviourExtensions
    {
        // ReSharper disable once UnusedMethodReturnValue.Global
        internal static Coroutine StartCoroutineIfGameObjectActive(this MonoBehaviour behaviour, IEnumerator routine) =>
            behaviour.gameObject.activeInHierarchy ? behaviour.StartCoroutine(routine) : null;

        internal static T AddComponent<T>(this GameObject go, Action<T> callback) where T : MonoBehaviour
        {
            var component = go.AddComponent<T>();
            callback(component);
            return component;
        }
    }
}
