using System.Diagnostics.CodeAnalysis;
using UnityEngine;

namespace NAT
{
    [SuppressMessage("ReSharper", "UnusedMember.Global")]
    [SuppressMessage("ReSharper", "UnusedType.Global")]
    static class QuaternionExtensions
    {
        internal static string ToPrettyString(this Quaternion q, string format = "0.000") =>
            $"({q.x.ToString(format)}, {q.y.ToString(format)}, {q.z.ToString(format)} {q.w.ToString(format)})";

        internal static bool IsEqual(this Quaternion q, Quaternion other, float tolerance = 0.001f) =>
            q.x.IsEqual(other.x, tolerance) &&
            q.y.IsEqual(other.y, tolerance) &&
            q.z.IsEqual(other.z, tolerance) &&
            q.w.IsEqual(other.w, tolerance);
    }
}
