using UnityEngine;

namespace NAT
{
    static class Vector3Extensions
    {
        internal static float RelativeTo(this Vector3 vector, Transform transform, Vector3 axis) =>
            Vector3.Dot(vector, transform.TransformDirection(axis));

        internal static string ToPrettyString(this Vector3 vector, string format = "0.000") =>
            $"({vector.x.ToString(format)}, {vector.y.ToString(format)}, {vector.z.ToString(format)})";

        internal static bool IsEqual(this Vector3 vector, Vector3 other, float tolerance = 0.001f) =>
            vector.x.IsEqual(other.x, tolerance) &&
            vector.y.IsEqual(other.y, tolerance) &&
            vector.z.IsEqual(other.z, tolerance);
    }
}
